/* Copyright (C) 2004 - 2007  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
package com.db4o.db4ounit.common.assorted;

import java.io.*;

import com.db4o.*;
import com.db4o.internal.*;

import db4ounit.*;
import db4ounit.extensions.*;
import db4ounit.extensions.fixtures.*;


public class FileSizeOnRollbackTestCase extends AbstractDb4oTestCase {

	public static void main(String[] args) {
		new FileSizeOnRollbackTestCase().runSolo();
	}
	
	public static class Item{
		public int _int; 
	}
	
	public void testFileSizeDoesNotIncrease(){
		
		storeSomeItems();
		produceSomeFreeSpace();
		
		int originalFileSize = fileSize();
		for (int i = 0; i < 100; i++) {
			store(new Item());
			db().rollback();
			Assert.areEqual(originalFileSize, fileSize());
		}
	}
	
	private void storeSomeItems(){
		for (int i = 0; i < 3; i++) {
			store(new Item());
		}
		db().commit();
	}
	
	private void produceSomeFreeSpace(){
		ObjectSet objectSet = newQuery(Item.class).execute();
		while(objectSet.hasNext()){
			db().delete(objectSet.next());
		}
		db().commit();
	}
	
	private int fileSize(){
		LocalObjectContainer localContainer = fixture().fileSession();
        IoAdaptedObjectContainer container = (IoAdaptedObjectContainer) localContainer;
        container.syncFiles();
        long length = new File(container.fileName()).length();
        return (int)length;
	}

}
